Bug 137907 - Change native call frames to use the scope from their Callee instead of their caller's scope
Summary: Change native call frames to use the scope from their Callee instead of their...
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: JavaScriptCore (show other bugs)
Version: 528+ (Nightly build)
Hardware: All All
: P2 Normal
Assignee: Michael Saboff
URL:
Keywords:
Depends on: 137839 137906
Blocks: 136724 136901
  Show dependency treegraph
 
Reported: 2014-10-20 18:53 PDT by Michael Saboff
Modified: 2014-10-22 14:14 PDT (History)
1 user (show)

See Also:


Attachments
Patch (15.20 KB, patch)
2014-10-21 11:52 PDT, Michael Saboff
mark.lam: review+
Details | Formatted Diff | Diff

Note You need to log in before you can comment on or make changes to this bug.
Description Michael Saboff 2014-10-20 18:53:45 PDT
Currently the scope for a native call frame is copied from their caller's scope.  This usually works, but is not the proper semantic.  The correct scope to use is the one from the callee.
Comment 1 Michael Saboff 2014-10-21 11:52:49 PDT
Created attachment 240213 [details]
Patch
Comment 2 Mark Lam 2014-10-21 12:14:43 PDT
Comment on attachment 240213 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=240213&action=review

> Source/JavaScriptCore/llint/LowLevelInterpreter32_64.asm:-2109
> -        # t1 already contains the Callee.

I don't think you should remove this comment.
Comment 3 Michael Saboff 2014-10-21 12:36:58 PDT
(In reply to comment #2)
> Comment on attachment 240213 [details]
> Patch
> 
> View in context:
> https://bugs.webkit.org/attachment.cgi?id=240213&action=review
> 
> > Source/JavaScriptCore/llint/LowLevelInterpreter32_64.asm:-2109
> > -        # t1 already contains the Callee.
> 
> I don't think you should remove this comment.

I put it back in.
Comment 4 Michael Saboff 2014-10-21 13:03:25 PDT
Committed r174996: <http://trac.webkit.org/changeset/174996>
Comment 6 Michael Saboff 2014-10-22 11:21:38 PDT
(In reply to comment #5)
> (In reply to comment #4)
> > Committed r174996: <http://trac.webkit.org/changeset/174996>
> 
> It broke the testapi tests on the CLOOP bots:
> https://build.webkit.org/builders/
> Apple%20Mavericks%20LLINT%20CLoop%20%28BuildAndTest%29/builds/9212/steps/
> webkit-jsc-cloop-test/logs/stdio

tracked in <https://bugs.webkit.org/show_bug.cgi?id=137971>